<?php

/**
 * New host related methods and variables
 */
class new_host_nacoma_Model extends host_nacoma_Model
{
	const TYPE = 'new_host';
	var $db_table = 'host';

	public $properties = array (
		'topic' => 'host_name',
		'var_index' => array (
			'Add this host?' => 'bool',
			'template' => 'select',
			'host_name' => 'string',
			'alias' => 'string',
			'display_name' => 'string',
			'address' => 'string',
			'contact_groups' => 'mselect',
			'hostgroups' => 'mselect',
			'parents' => 'mselect',
			'Autodetect Services' => 'checkbox',
			'Service Checks' => 'checkbox',
			'action_url' => 'actionurl',
			'file_id' => 'select',
			'Host logo' => 'image',
			'children' => 'mselect',
			'check_command' => 'select',
			'check_command_args' => 'string',
			'contacts' => 'mselect',
			'max_check_attempts' => 'int',
			'check_interval' => 'int',
			'retry_interval' => 'int',
			'check_period' => 'select',
			'obsess' => 'bool',
			'check_freshness' => 'bool',
			'freshness_threshold' => 'int',
			'active_checks_enabled' => 'bool',
			'passive_checks_enabled' => 'bool',
			'event_handler' => 'select',
			'event_handler_args' => 'string',
			'event_handler_enabled' => 'bool',
			'low_flap_threshold' => 'int',
			'high_flap_threshold' => 'int',
			'flap_detection_enabled' => 'bool',
			'flap_detection_options' => 'checkbox',
			'process_perf_data' => 'bool',
			'retain_status_information' => 'bool',
			'retain_nonstatus_information' => 'bool',
			'notification_interval' => 'int',
			'first_notification_delay' => 'int',
			'notification_period' => 'select',
			'notification_options' => 'checkbox',
			'notifications_enabled' => 'bool',
			'stalking_options' => 'checkbox',
			'register' => 'bool',
			'icon_image' => 'image',
			'icon_image_alt' => 'string',
			'statusmap_image' => 'image',
			'notes' => 'string',
			'notes_url' => 'notesurl',
			'2d_coords' => 'string'
		),
		'widget' => array (
			'register' => 'hidden'
		),
		'default' => array (
			'Add this host?' => '1',
			'template' => 'default-host-template',
			'Autodetect Services' => array (
				'net'
			),
			'Service Checks' => array (),
			'Host logo' => '',
			'file_id' => '',
			'host_name' => '',
			'alias' => '',
			'address' => '',
			'parents' => '',
			'check_command' => '',
			'check_command_args' => ''
		),
		'host_wizard_visible' => array (
			'Add this host?',
			'template',
			'host_name',
			'alias',
			'address',
			'contact_groups',
			'hostgroups',
			'parents',
			'Autodetect Services',
			'Service Checks',
			'action_url',
			'Host logo',
			'file_id'
		),
		'required' => array (
			'host_name',
			'template',
			'file_id'
		),
		'special' => array (
			'Host logo' => false, /* Set in __construct */
			'Autodetect Services' => array (
				'net' => 'Autodetect Network Services(PING, SMTP, agents, etc)'
			),
			'Service Checks' => array (
				'nrpe' => 'Add UNIX Client Services(NRPE)',
				'nsclient' => 'Add Windows Client Services(NSClient)',
				'sensatronics-e4' => 'Add Sensatronics E4',
				'sensatronics-em1' => 'Add Sensatronics EM1',
				'netware' => 'Add NetWare Client Services(NWStat)',
				'wmi' => 'Add WMI'
			),
			'stalking_options' => array (
				'd' => 'Down',
				'u' => 'Unreachable',
				'o' => 'Up',
				'n' => false
			),
			'notification_options' => array (
				'd' => 'Down',
				'u' => 'Unreachable',
				'r' => 'Recovery',
				'f' => 'Flapping start and stop',
				's' => 'Scheduled downtime start and stop',
				'n' => false
			),
			'template' => 'host_template',
			'file_id' => 'FILE',
			'parents' => 'host',
			'children' => 'host',
			'check_command' => 'command',
			'event_handler' => 'command',
			'check_period' => 'timeperiod',
			'notification_period' => 'timeperiod',
			'hostgroups' => 'hostgroup',
			'contacts' => 'contact',
			'contact_groups' => 'contactgroup',
			'flap_detection_options' => array (
				'd' => 'Down',
				'u' => 'Unreachable',
				'o' => 'Up',
				'n' => false
			),
			'icon_image' => false, /* Set in __construct */
			'statusmap_image' => false /* Set in __construct */
		)
	);


	/**
	 * Update images specials, and call parent
	 */
	public function __construct($id = false) {
		$this->properties['special']['Host logo'] = $this->get_images();
		parent::__construct($id);
	}

	public function get_object_name()
	{
		if (isset($this->obj['host_name']))
			return 'New host ' . $this->obj['host_name'];
		return 'New host';
	}

}
